(function (root, factory) {
  if (typeof define === 'function' && define.amd)
    define(['exports', 'kotlin', 'ktor-ktor-utils-js-legacy', 'ktor-ktor-http-js-legacy', 'ktor-ktor-client-core-js-legacy', 'ktor-ktor-io-js-legacy'], factory);
  else if (typeof exports === 'object')
    factory(module.exports, require('kotlin'), require('ktor-ktor-utils-js-legacy'), require('ktor-ktor-http-js-legacy'), require('ktor-ktor-client-core-js-legacy'), require('ktor-ktor-io-js-legacy'));
  else {
    if (typeof kotlin === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-client-encoding-js-legacy'. Its dependency 'kotlin' was not found. Please, check whether 'kotlin' is loaded prior to 'ktor-ktor-client-encoding-js-legacy'.");
    }
    if (typeof this['ktor-ktor-utils-js-legacy'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-client-encoding-js-legacy'. Its dependency 'ktor-ktor-utils-js-legacy' was not found. Please, check whether 'ktor-ktor-utils-js-legacy' is loaded prior to 'ktor-ktor-client-encoding-js-legacy'.");
    }
    if (typeof this['ktor-ktor-http-js-legacy'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-client-encoding-js-legacy'. Its dependency 'ktor-ktor-http-js-legacy' was not found. Please, check whether 'ktor-ktor-http-js-legacy' is loaded prior to 'ktor-ktor-client-encoding-js-legacy'.");
    }
    if (typeof this['ktor-ktor-client-core-js-legacy'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-client-encoding-js-legacy'. Its dependency 'ktor-ktor-client-core-js-legacy' was not found. Please, check whether 'ktor-ktor-client-core-js-legacy' is loaded prior to 'ktor-ktor-client-encoding-js-legacy'.");
    }
    if (typeof this['ktor-ktor-io-js-legacy'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-client-encoding-js-legacy'. Its dependency 'ktor-ktor-io-js-legacy' was not found. Please, check whether 'ktor-ktor-io-js-legacy' is loaded prior to 'ktor-ktor-client-encoding-js-legacy'.");
    }
    root['ktor-ktor-client-encoding-js-legacy'] = factory(typeof this['ktor-ktor-client-encoding-js-legacy'] === 'undefined' ? {} : this['ktor-ktor-client-encoding-js-legacy'], kotlin, this['ktor-ktor-utils-js-legacy'], this['ktor-ktor-http-js-legacy'], this['ktor-ktor-client-core-js-legacy'], this['ktor-ktor-io-js-legacy']);
  }
}(this, function (_, Kotlin, $module$ktor_ktor_utils_js_legacy, $module$ktor_ktor_http_js_legacy, $module$ktor_ktor_client_core_js_legacy, $module$ktor_ktor_io_js_legacy) {
  'use strict';
  var Kind_INTERFACE = Kotlin.Kind.INTERFACE;
  var Encoder = $module$ktor_ktor_utils_js_legacy.io.ktor.util.Encoder;
  var util = $module$ktor_ktor_utils_js_legacy.io.ktor.util;
  var Kind_OBJECT = Kotlin.Kind.OBJECT;
  var http = $module$ktor_ktor_http_js_legacy.io.ktor.http;
  var split = Kotlin.kotlin.text.split_ip8yn$;
  var reversed = Kotlin.kotlin.collections.reversed_7wnvza$;
  var Unit = Kotlin.kotlin.Unit;
  var CaseInsensitiveMap = $module$ktor_ktor_utils_js_legacy.io.ktor.util.CaseInsensitiveMap;
  var Kind_CLASS = Kotlin.Kind.CLASS;
  var HttpRequestPipeline = $module$ktor_ktor_client_core_js_legacy.io.ktor.client.request.HttpRequestPipeline;
  var COROUTINE_SUSPENDED = Kotlin.kotlin.coroutines.intrinsics.COROUTINE_SUSPENDED;
  var CoroutineImpl = Kotlin.kotlin.coroutines.CoroutineImpl;
  var HttpResponsePipeline = $module$ktor_ktor_client_core_js_legacy.io.ktor.client.statement.HttpResponsePipeline;
  var contentLength = $module$ktor_ktor_http_js_legacy.io.ktor.http.contentLength_v1wgmc$;
  var L0 = Kotlin.Long.ZERO;
  var equals = Kotlin.equals;
  var HttpMethod = $module$ktor_ktor_http_js_legacy.io.ktor.http.HttpMethod;
  var ByteReadChannel = $module$ktor_ktor_io_js_legacy.io.ktor.utils.io.ByteReadChannel;
  var HttpResponseContainer = $module$ktor_ktor_client_core_js_legacy.io.ktor.client.statement.HttpResponseContainer;
  var AttributeKey = $module$ktor_ktor_utils_js_legacy.io.ktor.util.AttributeKey;
  var HttpClientPlugin = $module$ktor_ktor_client_core_js_legacy.io.ktor.client.plugins.HttpClientPlugin;
  var rangeTo = Kotlin.kotlin.ranges.rangeTo_38ydlf$;
  var contains = Kotlin.kotlin.ranges.contains_u6rtyw$;
  var take = Kotlin.kotlin.text.take_6ic1pp$;
  var IllegalStateException_init = Kotlin.kotlin.IllegalStateException_init_pdl1vj$;
  var IllegalStateException = Kotlin.kotlin.IllegalStateException;
  var StringBuilder_init = Kotlin.kotlin.text.StringBuilder_init;
  var throwCCE = Kotlin.throwCCE;
  var trim = Kotlin.kotlin.text.trim_gw00vp$;
  var collectionSizeOrDefault = Kotlin.kotlin.collections.collectionSizeOrDefault_ba2ldo$;
  var ArrayList_init = Kotlin.kotlin.collections.ArrayList_init_ww73n8$;
  UnsupportedContentEncodingException.prototype = Object.create(IllegalStateException.prototype);
  UnsupportedContentEncodingException.prototype.constructor = UnsupportedContentEncodingException;
  function ContentEncoder() {
  }
  ContentEncoder.$metadata$ = {
    kind: Kind_INTERFACE,
    simpleName: 'ContentEncoder',
    interfaces: [Encoder]
  };
  function IdentityEncoder() {
    IdentityEncoder_instance = this;
    this.$delegate_unwv9b$_0 = util.Identity;
    this.name_k1jhwg$_0 = 'identity';
  }
  Object.defineProperty(IdentityEncoder.prototype, 'name', {
    configurable: true,
    get: function () {
      return this.name_k1jhwg$_0;
    }
  });
  IdentityEncoder.prototype.decode_40pv3p$ = function ($receiver, source) {
    return this.$delegate_unwv9b$_0.decode_40pv3p$($receiver, source);
  };
  IdentityEncoder.prototype.encode_40pv3p$ = function ($receiver, source) {
    return this.$delegate_unwv9b$_0.encode_40pv3p$($receiver, source);
  };
  IdentityEncoder.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'IdentityEncoder',
    interfaces: [ContentEncoder, Encoder]
  };
  var IdentityEncoder_instance = null;
  function IdentityEncoder_getInstance() {
    if (IdentityEncoder_instance === null) {
      new IdentityEncoder();
    }
    return IdentityEncoder_instance;
  }
  function ContentEncoding(encoders, qualityValues) {
    ContentEncoding$Companion_getInstance();
    this.encoders_0 = encoders;
    this.qualityValues_0 = qualityValues;
    var $receiver = StringBuilder_init();
    var tmp$, tmp$_0;
    tmp$ = this.encoders_0.values.iterator();
    while (tmp$.hasNext()) {
      var encoder = tmp$.next();
      if ($receiver.length > 0)
        $receiver.append_s8itvh$(44);
      $receiver.append_pdl1vj$(encoder.name);
      tmp$_0 = this.qualityValues_0.get_11rb$(encoder.name);
      if (tmp$_0 == null) {
        continue;
      }
      var quality = tmp$_0;
      if (!contains(rangeTo(0.0, 1.0), quality)) {
        var message = 'Invalid quality value: ' + quality + ' for encoder: ' + encoder;
        throw IllegalStateException_init(message.toString());
      }
      var qualityValue = take(quality.toString(), 5);
      $receiver.append_pdl1vj$(';q=' + qualityValue);
    }
    this.requestHeader_0 = $receiver.toString();
  }
  ContentEncoding.prototype.setRequestHeaders_0 = function (headers) {
    if (headers.contains_61zpoe$(http.HttpHeaders.AcceptEncoding))
      return;
    headers.set_puj7f4$(http.HttpHeaders.AcceptEncoding, this.requestHeader_0);
  };
  ContentEncoding.prototype.decode_0 = function ($receiver, headers, content) {
    var tmp$, tmp$_0, tmp$_1, tmp$_2, tmp$_3;
    var tmp$_4;
    if ((tmp$_0 = (tmp$ = headers.get_61zpoe$(http.HttpHeaders.ContentEncoding)) != null ? split(tmp$, [',']) : null) != null) {
      var destination = ArrayList_init(collectionSizeOrDefault(tmp$_0, 10));
      var tmp$_5;
      tmp$_5 = tmp$_0.iterator();
      while (tmp$_5.hasNext()) {
        var item = tmp$_5.next();
        var tmp$_6;
        destination.add_11rb$(trim(Kotlin.isCharSequence(tmp$_6 = item) ? tmp$_6 : throwCCE()).toString().toLowerCase());
      }
      tmp$_4 = destination;
    } else
      tmp$_4 = null;
    tmp$_1 = tmp$_4;
    if (tmp$_1 == null) {
      return content;
    }
    var encodings = tmp$_1;
    var current = {v: content};
    tmp$_2 = reversed(encodings).iterator();
    while (tmp$_2.hasNext()) {
      var encoding = tmp$_2.next();
      tmp$_3 = this.encoders_0.get_11rb$(encoding);
      if (tmp$_3 == null) {
        throw new UnsupportedContentEncodingException(encoding);
      }
      var encoder = tmp$_3;
      current.v = encoder.decode_40pv3p$($receiver, current.v);
    }
    return current.v;
  };
  function ContentEncoding$Config() {
    this.encoders_8be2vx$ = new CaseInsensitiveMap();
    this.qualityValues_8be2vx$ = new CaseInsensitiveMap();
  }
  ContentEncoding$Config.prototype.gzip_81sz4$ = function (quality) {
    if (quality === void 0)
      quality = null;
    this.customEncoder_acwsre$(GZipEncoder_getInstance(), quality);
  };
  ContentEncoding$Config.prototype.deflate_81sz4$ = function (quality) {
    if (quality === void 0)
      quality = null;
    this.customEncoder_acwsre$(DeflateEncoder_getInstance(), quality);
  };
  ContentEncoding$Config.prototype.identity_81sz4$ = function (quality) {
    if (quality === void 0)
      quality = null;
    this.customEncoder_acwsre$(IdentityEncoder_getInstance(), quality);
  };
  ContentEncoding$Config.prototype.customEncoder_acwsre$ = function (encoder, quality) {
    if (quality === void 0)
      quality = null;
    var name = encoder.name;
    var tmp$ = this.encoders_8be2vx$;
    var key = name.toLowerCase();
    tmp$.put_xwzc9p$(key, encoder);
    if (quality == null) {
      this.qualityValues_8be2vx$.remove_11rb$(name);
    } else {
      this.qualityValues_8be2vx$.put_xwzc9p$(name, quality);
    }
  };
  ContentEncoding$Config.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'Config',
    interfaces: []
  };
  function ContentEncoding$Companion() {
    ContentEncoding$Companion_instance = this;
    this.key_nehpzy$_0 = new AttributeKey('HttpEncoding');
  }
  Object.defineProperty(ContentEncoding$Companion.prototype, 'key', {
    configurable: true,
    get: function () {
      return this.key_nehpzy$_0;
    }
  });
  ContentEncoding$Companion.prototype.prepare_oh3mgy$$default = function (block) {
    var $receiver = new ContentEncoding$Config();
    block($receiver);
    var config = $receiver;
    return new ContentEncoding(config.encoders_8be2vx$, config.qualityValues_8be2vx$);
  };
  function Coroutine$ContentEncoding$Companion$install$lambda(closure$plugin_0, $receiver_0, it_0, controller, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.$controller = controller;
    this.exceptionState_0 = 1;
    this.local$closure$plugin = closure$plugin_0;
    this.local$$receiver = $receiver_0;
  }
  Coroutine$ContentEncoding$Companion$install$lambda.$metadata$ = {
    kind: Kotlin.Kind.CLASS,
    simpleName: null,
    interfaces: [CoroutineImpl]
  };
  Coroutine$ContentEncoding$Companion$install$lambda.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$ContentEncoding$Companion$install$lambda.prototype.constructor = Coroutine$ContentEncoding$Companion$install$lambda;
  Coroutine$ContentEncoding$Companion$install$lambda.prototype.doResume = function () {
    do
      try {
        switch (this.state_0) {
          case 0:
            return this.local$closure$plugin.setRequestHeaders_0(this.local$$receiver.context.headers), Unit;
          case 1:
            throw this.exception_0;
          default:
            this.state_0 = 1;
            throw new Error('State Machine Unreachable execution');
        }
      } catch (e) {
        if (this.state_0 === 1) {
          this.exceptionState_0 = this.state_0;
          throw e;
        } else {
          this.state_0 = this.exceptionState_0;
          this.exception_0 = e;
        }
      }
     while (true);
  };
  function ContentEncoding$Companion$install$lambda(closure$plugin_0) {
    return function ($receiver_0, it_0, continuation_0, suspended) {
      var instance = new Coroutine$ContentEncoding$Companion$install$lambda(closure$plugin_0, $receiver_0, it_0, this, continuation_0);
      if (suspended)
        return instance;
      else
        return instance.doResume(null);
    };
  }
  function Coroutine$ContentEncoding$Companion$install$lambda_0(closure$plugin_0, $receiver_0, f_0, controller, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.$controller = controller;
    this.exceptionState_0 = 1;
    this.local$closure$plugin = closure$plugin_0;
    this.local$type = void 0;
    this.local$content = void 0;
    this.local$method = void 0;
    this.local$contentLength = void 0;
    this.local$$receiver = $receiver_0;
    this.local$f = f_0;
  }
  Coroutine$ContentEncoding$Companion$install$lambda_0.$metadata$ = {
    kind: Kotlin.Kind.CLASS,
    simpleName: null,
    interfaces: [CoroutineImpl]
  };
  Coroutine$ContentEncoding$Companion$install$lambda_0.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$ContentEncoding$Companion$install$lambda_0.prototype.constructor = Coroutine$ContentEncoding$Companion$install$lambda_0;
  Coroutine$ContentEncoding$Companion$install$lambda_0.prototype.doResume = function () {
    do
      try {
        switch (this.state_0) {
          case 0:
            this.local$type = this.local$f.component1(), this.local$content = this.local$f.component2();
            this.local$method = this.local$$receiver.context.request.method;
            this.local$contentLength = contentLength(this.local$$receiver.context.response);
            if (equals(this.local$contentLength, L0)) {
              return;
            } else {
              this.state_0 = 2;
              continue;
            }

          case 1:
            throw this.exception_0;
          case 2:
            if (this.local$contentLength == null && (this.local$method != null ? this.local$method.equals(HttpMethod.Companion.Head) : null)) {
              return;
            } else {
              this.state_0 = 3;
              continue;
            }

          case 3:
            if (!Kotlin.isType(this.local$content, ByteReadChannel)) {
              return;
            } else {
              this.state_0 = 4;
              continue;
            }

          case 4:
            var response = new HttpResponseContainer(this.local$type, this.local$closure$plugin.decode_0(this.local$$receiver.context, this.local$$receiver.context.response.headers, this.local$content));
            this.state_0 = 5;
            this.result_0 = this.local$$receiver.proceedWith_trkh7z$(response, this);
            if (this.result_0 === COROUTINE_SUSPENDED)
              return COROUTINE_SUSPENDED;
            continue;
          case 5:
            return this.result_0;
          default:
            this.state_0 = 1;
            throw new Error('State Machine Unreachable execution');
        }
      } catch (e) {
        if (this.state_0 === 1) {
          this.exceptionState_0 = this.state_0;
          throw e;
        } else {
          this.state_0 = this.exceptionState_0;
          this.exception_0 = e;
        }
      }
     while (true);
  };
  function ContentEncoding$Companion$install$lambda_0(closure$plugin_0) {
    return function ($receiver_0, f_0, continuation_0, suspended) {
      var instance = new Coroutine$ContentEncoding$Companion$install$lambda_0(closure$plugin_0, $receiver_0, f_0, this, continuation_0);
      if (suspended)
        return instance;
      else
        return instance.doResume(null);
    };
  }
  ContentEncoding$Companion.prototype.install_wojrb5$ = function (plugin, scope) {
    scope.requestPipeline.intercept_h71y74$(HttpRequestPipeline.Phases.State, ContentEncoding$Companion$install$lambda(plugin));
    scope.responsePipeline.intercept_h71y74$(HttpResponsePipeline.Phases.Receive, ContentEncoding$Companion$install$lambda_0(plugin));
  };
  ContentEncoding$Companion.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'Companion',
    interfaces: [HttpClientPlugin]
  };
  var ContentEncoding$Companion_instance = null;
  function ContentEncoding$Companion_getInstance() {
    if (ContentEncoding$Companion_instance === null) {
      new ContentEncoding$Companion();
    }
    return ContentEncoding$Companion_instance;
  }
  ContentEncoding.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'ContentEncoding',
    interfaces: []
  };
  function ContentEncoding$lambda($receiver) {
    $receiver.gzip_81sz4$();
    $receiver.deflate_81sz4$();
    $receiver.identity_81sz4$();
    return Unit;
  }
  function ContentEncoding_0($receiver, block) {
    if (block === void 0)
      block = ContentEncoding$lambda;
    $receiver.install_dq2y33$(ContentEncoding$Companion_getInstance(), block);
  }
  function UnsupportedContentEncodingException(encoding) {
    IllegalStateException_init('Content-Encoding: ' + encoding + ' unsupported.', this);
    this.name = 'UnsupportedContentEncodingException';
  }
  UnsupportedContentEncodingException.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'UnsupportedContentEncodingException',
    interfaces: [IllegalStateException]
  };
  function GZipEncoder() {
    GZipEncoder_instance = this;
    this.$delegate_ao42m5$_0 = util.Identity;
    this.name_z6n8ys$_0 = 'gzip';
  }
  Object.defineProperty(GZipEncoder.prototype, 'name', {
    configurable: true,
    get: function () {
      return this.name_z6n8ys$_0;
    }
  });
  GZipEncoder.prototype.decode_40pv3p$ = function ($receiver, source) {
    return this.$delegate_ao42m5$_0.decode_40pv3p$($receiver, source);
  };
  GZipEncoder.prototype.encode_40pv3p$ = function ($receiver, source) {
    return this.$delegate_ao42m5$_0.encode_40pv3p$($receiver, source);
  };
  GZipEncoder.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'GZipEncoder',
    interfaces: [ContentEncoder, Encoder]
  };
  var GZipEncoder_instance = null;
  function GZipEncoder_getInstance() {
    if (GZipEncoder_instance === null) {
      new GZipEncoder();
    }
    return GZipEncoder_instance;
  }
  function DeflateEncoder() {
    DeflateEncoder_instance = this;
    this.$delegate_uyf434$_0 = util.Identity;
    this.name_l47snj$_0 = 'deflate';
  }
  Object.defineProperty(DeflateEncoder.prototype, 'name', {
    configurable: true,
    get: function () {
      return this.name_l47snj$_0;
    }
  });
  DeflateEncoder.prototype.decode_40pv3p$ = function ($receiver, source) {
    return this.$delegate_uyf434$_0.decode_40pv3p$($receiver, source);
  };
  DeflateEncoder.prototype.encode_40pv3p$ = function ($receiver, source) {
    return this.$delegate_uyf434$_0.encode_40pv3p$($receiver, source);
  };
  DeflateEncoder.$metadata$ = {
    kind: Kind_OBJECT,
    simpleName: 'DeflateEncoder',
    interfaces: [ContentEncoder, Encoder]
  };
  var DeflateEncoder_instance = null;
  function DeflateEncoder_getInstance() {
    if (DeflateEncoder_instance === null) {
      new DeflateEncoder();
    }
    return DeflateEncoder_instance;
  }
  var package$io = _.io || (_.io = {});
  var package$ktor = package$io.ktor || (package$io.ktor = {});
  var package$client = package$ktor.client || (package$ktor.client = {});
  var package$plugins = package$client.plugins || (package$client.plugins = {});
  var package$compression = package$plugins.compression || (package$plugins.compression = {});
  package$compression.ContentEncoder = ContentEncoder;
  Object.defineProperty(package$compression, 'IdentityEncoder', {
    get: IdentityEncoder_getInstance
  });
  ContentEncoding.Config = ContentEncoding$Config;
  Object.defineProperty(ContentEncoding, 'Companion', {
    get: ContentEncoding$Companion_getInstance
  });
  package$compression.ContentEncoding = ContentEncoding;
  package$compression.ContentEncoding_s6f1xn$ = ContentEncoding_0;
  package$compression.UnsupportedContentEncodingException = UnsupportedContentEncodingException;
  Object.defineProperty(package$compression, 'GZipEncoder', {
    get: GZipEncoder_getInstance
  });
  Object.defineProperty(package$compression, 'DeflateEncoder', {
    get: DeflateEncoder_getInstance
  });
  ContentEncoding$Companion.prototype.prepare_oh3mgy$ = HttpClientPlugin.prototype.prepare_oh3mgy$;
  Kotlin.defineModule('ktor-ktor-client-encoding-js-legacy', _);
  return _;
}));

//# sourceMappingURL=ktor-ktor-client-encoding-js-legacy.js.map
